# %{pversion}, %{version}, %{rel} are provided by the Makefile
%define docdir /opt/lsb/doc/%{name}
%define topdir /opt/lsb/test/perl
Summary: LSB Perl Test Suite
Name: lsb-test-perl
Version: %{version}
Release: %{rel}
License: Artistic
Group: Development/Tools
Source: http://ftp.funet.fi/pub/CPAN/src/perl-%{pversion}.tar.bz2
Source1: tet_functions.pl
Patch0: perl-test-system-perl.patch
Patch1: perl-test-set-euid.patch
Patch2: perl-test-tet-output.patch
Patch3: perl-test-bug-1888.patch
URL: http://www.linuxbase.org/test
#Prefix: %{_prefix}
BuildRoot: %{_tmppath}/%{name}-root
AutoReqProv: no
BuildArch: noarch
Requires: lsb-tet3-lite

%description
This is the official package version of the LSB Perl test suite. 
These tests are derived from Perl's build-time tests.

#==================================================
%prep
%setup -q -n perl-%{pversion}
%patch0 -p0 -b .system-perl
%patch1 -p0 -b .set-euid
%patch3 -p0 -b .1888
 
#==================================================
%build
# modify harness for TET output
cp lib/Test/Harness.pm t
patch -p0 -b -z .tet-output < %{PATCH2}

# need macros.all
pushd ext/Sys/Syslog
perl Makefile.PL
popd

#==================================================
%install

rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{topdir}
mkdir -p ${RPM_BUILD_ROOT}%{topdir}/results

# core/base tests
cp -prf t ${RPM_BUILD_ROOT}%{topdir}

mkdir -p ${RPM_BUILD_ROOT}%{topdir}/lib/unicore
cp -prf lib/unicore/CaseFolding.txt ${RPM_BUILD_ROOT}%{topdir}/lib/unicore

# lib/t*
mkdir -p ${RPM_BUILD_ROOT}%{topdir}/lib
for test in `find lib -name '*.t'`;do
  dir=`dirname $test`
  mkdir -p ${RPM_BUILD_ROOT}%{topdir}/$dir
  cp -p $test ${RPM_BUILD_ROOT}%{topdir}/$dir
done
for inc in `find lib -name '*.inc'`;do
  dir=`dirname $inc`
  cp -p $inc ${RPM_BUILD_ROOT}%{topdir}/$dir
done

# Pod tests need these
cp -p lib/Pod/t/basic.{pod,man,cap,clr,ovr,txt} ${RPM_BUILD_ROOT}%{topdir}/lib/Pod/t
cp -p lib/Pod/t/htmlescp.pod ${RPM_BUILD_ROOT}%{topdir}/lib/Pod/t
cp -p lib/Pod/t/htmllink.pod ${RPM_BUILD_ROOT}%{topdir}/lib/Pod/t
cp -p lib/Pod/t/htmlview.pod ${RPM_BUILD_ROOT}%{topdir}/lib/Pod/t

# ext/t*
mkdir -p ${RPM_BUILD_ROOT}%{topdir}/ext
for test in `find ext -name *.t`;do
  dir=`dirname $test`
  mkdir -p ${RPM_BUILD_ROOT}%{topdir}/$dir
  cp -p $test ${RPM_BUILD_ROOT}%{topdir}/$dir
done

mkdir -p ${RPM_BUILD_ROOT}%{topdir}/pod
cp -prf pod/pod2usage.PL ${RPM_BUILD_ROOT}%{topdir}/pod
cp -prf pod/podselect.PL ${RPM_BUILD_ROOT}%{topdir}/pod

# not needed - inappropriate for our purposes
# ph.t is obsolete, see
# http://www.linux-foundation.org/en/LsbTestPerl32Results#SLES10_ia32_results
for test in h2ph h2xs ph;do
  rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/$test.t
done
rm -fr ${RPM_BUILD_ROOT}%{topdir}/t/win32
rm -f ${RPM_BUILD_ROOT}%{topdir}/t/lib/cygwin.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/ext/Cwd/t/win32.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/attrs/t/attrs.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/vars.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/vmsish.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/ExtUtils/t/vmsish.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/ExtUtils/t/MM_{BeOS,Cygwin,NW5,OS2,VMS,Win32}.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/Tie/File/t/21_win32.t

# not maintained/experimental - dropped in 5.9.x
rm -f ${RPM_BUILD_ROOT}%{topdir}/ext/B/t/asmdata.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/ext/B/t/bblock.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/ext/B/t/bytecode.t

# skipped in most if not all cases - drop them
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/Test/Harness/t/prove-*
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/Net/t/{f,nn,sm}tp.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/Test/Simple/t/strays.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/ExtUtils/t/xs.t

# old threads implementation
rm -f ${RPM_BUILD_ROOT}%{topdir}/ext/Thread/thr5005.t

# not shipped by all distributions
rm -fr ${RPM_BUILD_ROOT}%{topdir}/ext/DB_File
rm -fr ${RPM_BUILD_ROOT}%{topdir}/ext/NDBM_File
rm -fr ${RPM_BUILD_ROOT}%{topdir}/ext/ODBM_File
# missed this one - bug 1887
rm -fr ${RPM_BUILD_ROOT}%{topdir}/lib/Memoize/t/tie_ndbm.t

# begin test trim based on lsb-perl
# threads are not required
rm -fr ${RPM_BUILD_ROOT}%{topdir}/ext/threads
rm -f ${RPM_BUILD_ROOT}%{topdir}/ext/Storable/t/threads.t
rm -fr ${RPM_BUILD_ROOT}%{topdir}/lib/Thread
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/Test/Simple/t/{sort_bug,threads}.t
rm -f ${RPM_BUILD_ROOT}%{topdir}/t/op/{getpid,threads}.t

# test is designed to skip - just muddies the waters
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/Test/Simple/t/plan_skip_all.t

# requires Test::Pod - not in core perl
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/Test/Harness/t/pod.t

# requires Compress::Zlib - not in core perl
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/DBM_Filter/t/compress.t

# needs echo service, network - not practical
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/Net/Ping/t/300_ping_stream.t

# no getnetbyname in LSB - lsb-perl does not have Net::netent
rm -f ${RPM_BUILD_ROOT}%{topdir}/lib/Net/netent.t

# seems to get skipped on most platforms - drop it
rm -f  ${RPM_BUILD_ROOT}%{topdir}/ext/Storable/t/interwork56.t

# 64bit tests - drop so results are consistant across archs
rm -f  ${RPM_BUILD_ROOT}%{topdir}/ext/Fcntl/t/syslfs.t
rm -f  ${RPM_BUILD_ROOT}%{topdir}/t/op/{64bitint,lfs}.t

# end test trim

#==================================================
# setup some symlinks to the system files
mkdir -p ${RPM_BUILD_ROOT}%{topdir}/x2p
pushd ${RPM_BUILD_ROOT}%{topdir}/x2p
ln -s /usr/bin/psed .
ln -s /usr/bin/s2p .
cd ../t
ln -s /usr/bin/perl .
# magic test - some distros symlink perl -> perl%{pversion}
# while some have both binaries, use the versioned one 
cd ..
ln -s /usr/bin/perl%{pversion} perl
popd

# build our MANIFEST file
pushd ${RPM_BUILD_ROOT}%{topdir}
find . -name '*.t' | cut -c3- > MANIFEST
popd
# ExtUtil tests expect to find these
find lib/ExtUtils -name *.pm >> ${RPM_BUILD_ROOT}%{topdir}/MANIFEST
chmod -w ${RPM_BUILD_ROOT}%{topdir}/MANIFEST

# and the test script
cat > run_tests << EOF
#!/bin/sh
PATH=\$PATH:/opt/lsb/bin

perl_version() {
  perl_ver=\`/usr/bin/perl -V:version | sed "s|version=||g;s|;||g;s|'||g"\`
  echo "System perl version is: \$perl_ver"
}

save_journal() {
  last_dir=\`find results -name '00*e' | sort -n | tail -1 | cut  -c11- | cut -c-2\`
  next_dir=\`expr \$last_dir + 1\`
  next_dir=\`printf "%02d" \$next_dir\`
  next_dir="results/00\$next_dir"e
  mkdir \$next_dir
  mv t/tet_xres \$next_dir/journal
  echo "Journal file is \$next_dir/journal"
}

unicode_symlink() {
  if [ ! -h lib/unicore/lib ];then
    echo "Creating Unicode Character Database symlink..."
    cd lib/unicore
    if [ -d "\$installprivlib/unicore/lib" ];then
      ln -s "\$installprivlib/unicore/lib" .
    else
      echo "Cannot find the Unicode Character Database"
      echo "Test uni/class.t will most likely fail"
      sleep 10
    fi
    cd ../..
  fi
}

memoize_symlink() {
  cd lib
  for pfile in blib.pm constant.pm strict.pm;do
    if [ ! -h "\$pfile" ]; then
      echo "Creating symlink to system \$pfile"
      if [ -f "\$installprivlib/\$pfile" ];then
        ln -s "\$installprivlib/\$pfile" .
      else
        echo "Cannot find \$pfile in the installed perl"
        echo "Test lib/Tie/Memoize.t will most likely fail"
        sleep 10
      fi
    fi
  done
  cd ..
}

pod_symlink() {
  cd lib/Pod
  if [ ! -h "Functions.pm" ]; then
      echo "Creating symlink to system Functions.pm"
      if [ -f "\$installprivlib/Pod/Functions.pm" ];then
        ln -s "\$installprivlib/Pod/Functions.pm" .
      else
        echo "Cannot find Pod/Functions.pm in the installed perl"
        echo "Pod tests may fail"
        sleep 10
      fi
    fi
  cd ../..
}

# cleanup in case one switches back and forth from system perl to lsb-perl
clean_symlinks() {
  if [ -h "lib/unicore/lib" ];then
    rm -f lib/unicore/lib
  fi
  cd lib
  for pfile in blib.pm constant.pm strict.pm;do
    if [ -h "\$pfile" ];then
      rm -f "\$pfile"
    fi
  done
  if [ -h "Pod/Functions.pm" ];then
    rm -f Pod/Functions.pm
  fi
  cd ..
}

# for information only
perl_version
# get \$installprivlib
eval \`perl '-V:installprivlib'\`
unicode_symlink
memoize_symlink
pod_symlink
cd t
TET_ROOT=/opt/lsb-tet3-lite PERL_TEST_Net_Ping=1 PERL_SRC=../.. PERL=/usr/bin/perl /usr/bin/perl harness
cd ..
save_journal
clean_symlinks
EOF

chmod +x run_tests
cp -p run_tests ${RPM_BUILD_ROOT}%{topdir}

# special version of run_tests for lsb-perl
cp run_tests run_tests.lsb-perl
sed -i 's|/usr/bin/perl|/opt/lsb/appbat/bin/perl|g' run_tests.lsb-perl

chmod +x run_tests.lsb-perl
cp -p run_tests.lsb-perl ${RPM_BUILD_ROOT}%{topdir}

# single_test script
cat > single_test << EOF
#!/bin/sh
if [ -z "\$1" ];then
  printf "usage: \$0 <some_test>\n\t(some_test something like ../lib/integer.t or io/fs.t)\n"
  exit 1
fi

cd /opt/lsb/test/perl/t
TET_ROOT=/opt/lsb-tet3-lite PERL_SRC=../.. HARNESS_VERBOSE=1 PERL=/usr/bin/perl /usr/bin/perl harness \$1
EOF

chmod +x single_test
cp -p single_test ${RPM_BUILD_ROOT}%{topdir}

# and special single_tests for lsb-perl
cp single_test single_test.lsb-perl
sed -i 's|/usr/bin/perl|/opt/lsb/appbat/bin/perl|g' single_test.lsb-perl

chmod +x single_test.lsb-perl
cp -p single_test.lsb-perl ${RPM_BUILD_ROOT}%{topdir}

# our tet functions
cp -p %{SOURCE1} ${RPM_BUILD_ROOT}%{topdir}/t

# license and README.lsb-test
cat > README.lsb-test << EOF
Tests derived from the Perl %{pversion} build-time test suite
Packaged by the Linux Foundation for LSB compliance testing

For a completely successful run, you will need a compiler as well
as whatever distribution package provides libperl.so.
EOF

cat > README.lsb-test-lsb-perl << EOF
To test lsb-perl with the test suite, you need to change the perl 
binary symlinks in /opt/lsb/test/perl and /opt/lsb/test/perl/t
and the use run_tests.lsb-perl

cd /opt/lsb/test/perl
rm perl
ln -s /opt/lsb/appbat/bin/perl .
cd t
rm perl
ln -s /opt/lsb/appbat/bin/perl .

You will need to restore these links to /usr/bin/perl to run the
tests against the distribution perl.
EOF

cat > README.single-test << EOF
To run a single test:
cd /opt/lsb/test/perl/t
TET_ROOT=/opt/lsb-tet3-lite PERL_SRC=../.. PERL=/usr/bin/perl /usr/bin/perl harness some_test
(some_test would be something like ../lib/integer.t or io/fs.t)
To get more verbose output, set HARNESS_VERBOSE=1

Or use single_test some_test from /opt/lsb/test/perl
There is also single_test.lsb-perl for testing lsb-perl
EOF

# VERSION file for the journal
cat > VERSION << EOF
%{name} %{version}-%{rel} (noarch)
EOF
cp VERSION ${RPM_BUILD_ROOT}%{topdir}

# minimal docs  
mkdir -p ${RPM_BUILD_ROOT}%{docdir}
cp README.lsb-test README.lsb-test-lsb-perl README.single-test Artistic ${RPM_BUILD_ROOT}%{docdir}

# used by the CheckTree test
cp README INSTALL ${RPM_BUILD_ROOT}%{topdir}

# clean up stray .pm, .PL, README files
pushd ${RPM_BUILD_ROOT}%{topdir}
for name in README CHANGES ChangeLog;do
  find ext -name $name | xargs rm -f
  find lib -name $name | xargs rm -f
done
for dir in ext lib;do
  find $dir -name '*.pm' | xargs rm -f
  find $dir -name '*.pl' | xargs rm -f
  find $dir -name '*.PL' | xargs rm -f
  find $dir -name '*.xs' | xargs rm -f
done

# clean up the patch backup files
find . -name '*.system-perl' | xargs rm -if
find . -name '*.tet-output' | xargs rm -f
popd

# some specific files tests need
cp -p lib/Net/t/libnet_t.pl ${RPM_BUILD_ROOT}%{topdir}/lib/Net/t
cp -p lib/Pod/t/pod2html-lib.pl ${RPM_BUILD_ROOT}%{topdir}/lib/Pod/t
cp -p ext/Storable/t/st-dump.pl ${RPM_BUILD_ROOT}%{topdir}/ext/Storable/t
cp -p ext/B/t/OptreeCheck.pm ${RPM_BUILD_ROOT}%{topdir}/ext/B/t
cp -p ext/Digest/MD5/{Changes,MD5.pm,MD5.xs,README} ${RPM_BUILD_ROOT}%{topdir}/ext/Digest/MD5
cp -p ext/Encode/t/*.{enc,utf} ${RPM_BUILD_ROOT}%{topdir}/ext/Encode/t
cp -p ext/Encode/t/Mod_EUCJP.pm ${RPM_BUILD_ROOT}%{topdir}/ext/Encode/t
cp -p ext/Storable/t/testlib.pl ${RPM_BUILD_ROOT}%{topdir}/ext/Storable/t
cp -p ext/Storable/t/*.pm ${RPM_BUILD_ROOT}%{topdir}/ext/Storable/t
cp -p ext/Sys/Syslog/macros.all ${RPM_BUILD_ROOT}%{topdir}/ext/Sys/Syslog

#==================================================
%clean
if [ ! -z "${RPM_BUILD_ROOT}"  -a "${RPM_BUILD_ROOT}" != "/" ]; then 
    rm -rf ${RPM_BUILD_ROOT}
fi


#==================================================
%pre
# Need to create some groups and users beforehand because
# when the files are unpacked they need to be owned by the correct user
mkdir -p /home/tet/test_sets
groupadd vsxg0 > /dev/null 2>&1 || true
useradd -g vsxg0 -d /home/tet/test_sets -s /bin/sh -c "VSX0 test login" vsx0 > /dev/null 2>&1 || true

#======================================================================
%post

echo
echo To run the tests, please execute the following command:
echo "    cd %{topdir}; ./run_tests"
echo 
echo You will need to run the tests as root, or chown all of the files
echo to a user you want to run the tests as.
echo

#==================================================
%files
%defattr(-,root,root)

%dir %{topdir}
%{topdir}/*
%dir %{docdir}
%{docdir}/*

%defattr(-,vsx0,root)
%dir %{topdir}/t

#==================================================
%changelog
* Wed Jan 16 2008 Stew Benedict <stewb@linux-foundation.org>
- drop Memoize::NDBM_File test (bug 1887)
- disable the skip in lib/Net/t/hostname.t if $NetConfig{test_hosts} = 0 
  (bug 1888, P3)

* Fri Dec 14 2007 Stew Benedict <stewb@linux-foundation.org>
- redo P2 again, more journal cleanup for bug 1804
- use /usr/bin/perl for the version check too in run_tests
  (bug 1835)

* Tue Dec 04 2007 Stew Benedict <stewb@linux-foundation.org>
- add patch for bug 1804 (journal format, redo P2)

* Mon Dec 03 2007 Stew Benedict <stewb@linux-foundation.org>
- move license file to standard directory

* Mon Nov 12 2007 Stew Benedict <stewb@linux-foundation.org>
- Drop DB_File, NDBM_File, ODBM_File
- split version, pversion

* Fri Oct 12 2007 Stew Benedict <stewb@linux-foundation.org>
- update run_tests script, pick up the correct
  installprivlib for the perl being tested (fixes Tie/Memoize issue)

* Thu Oct 11 2007 Stew Benedict <stewb@linux-foundation.org>
- update README.lsb-perl to mention need for a compiler, libperl.so
  (exposed in Debian, Ubuntu testing - ExtUtils/t/Embed.t)
- add a new hunk to P2, we need to write a FAIL in the case where
  the test dies (also exposed in Debian, Ubuntu testing)
- cleanup the .tet-output patch backup files

* Wed Oct 10 2007 Stew Benedict <stewb@linux-foundation.org>
- add README.lsb-perl-test-lsb-perl
- add run_tests.lsb-perl script
- update README.single-test
- add single_test script

* Thu Jul 19 2007 Stew Benedict <stewb@linux-foundation.org>
- use the .bz2 tarball rather than .gz 
  (just to be consistant with other components using the perl tarball)
- sort the journals before we try to find the last one
- UNTESTED (skipped) tests now become FAILS (update P2)
- Requires: lsb-build-cc, lsb-tet3-lite (add /opt/lsb/bin to PATH)
- start trimming the test list a bit, based on what lsb-perl can pass
    ext/threads/*, lib/Thread/* - threads are not required
    lib/Test/Simple/t/{sort_bug,threads} - threads are not required
    op/{getpid,threads}, ext/Storable/t/threads - threads are not required
    ext/Storable/t/threads - threads are not required
    lib/Net/netent - LSB does not have getnetbyname - not built in lsb-perl
    lib/Test/Harness/t/pod - needs Test::Pod - not part of core perl
    lib/Test/Simple/t/plan_skip_all - test is supposed to skip, just drop
    lib/Net/Ping/t/300_ping_stream - 
				needs echo service, network - not practical
    ext/Storable/t/interwork56 - seems to skip on most platforms with
				"Your IVs are no larger than your longs"
    ext/Fcntl/t/syslfs.t, op/{64bitint,lfs} - 64 bit specific tests
    lib/DBM_Filter/t/compress.t - no Compress::Zlib
  
* Fri Jun 22 2007 Stew Benedict <stewb@linux-foundation.org>
- use %%topdir to define destination dir
- add some supplemental files some of the tests need
- more patching for the new tests (expanded P0)
- link blib.pm, constant.pm, strict.pm to system files for Tie::Memoize test
- use installed system perl version, not our build version, for setting up links
- link Pod/Functions.pm to system file
- enable ping tests
- drop B::{Asmdata,Bblock,Bytecode}
- build ext/Sys/Syslog/macros.all
- define PERL_SRC env variable
- drop some tests that are always skipped anyway
- let vsx0 own the "t" dir and change the effective uid to vsx0 for some
  tests that either don't run as root, or get skipped (P1)
- override "skips" in harness so we at least the same journal count
  regardless of system config (added to P2)

* Mon Jun 11 2007 Stew Benedict <stewb@linux-foundation.org>
- put bigfloatpl, bigintpl back
- remove attrs
- expand the list to all ext/lib and only filter out 
  the specifics we do not want
- more patching for the new tests
- add some ExtUtils .pm files to MANIFEST as tests expect them

* Thu Jun 07 2007 Stew Benedict <stewb@linux-foundation.org>
- Add Math::Big*
- remove vars, vmsish, bigfloatpl, bigingtpl

* Thu May 31 2007 Stew Benedict <stewb@linux-foundation.org>
- create the lib/unicore/lib symlink at runtime rather than build time
- rework op/magic.t patch for variations on runtimes

* Tue May 22 2007 Stew Benedict
- initial packaging

